HandyEggFinderDB = {random = true, warn = true}

local silence = false
local sounds = {
    "Sound\\Spells\\CrowdCheerAlliance1.wav",
    "Sound\\Spells\\CrowdCheerAlliance2.wav",
    "Sound\\Spells\\CrowdCheerHorde1.wav",
    "Sound\\Spells\\CrowdCheerHorde2.wav",
    "Sound\\Spells\\WarriorSwings\\SwingWeaponSpecialWarriorA.wav",
    "Sound\\Spells\\WarriorSwings\\SwingWeaponSpecialWarriorB.wav",
    "Sound\\Spells\\WarriorSwings\\SwingWeaponSpecialWarriorC.wav",
    "Sound\\Spells\\WarriorSwings\\SwingWeaponSpecialWarriorD.wav",
    "Sound\\Spells\\WarriorSwings\\SwingWeaponSpecialWarriorE.wav",
    "Sound\\Spells\\WaterElemental_Impact_Base.wav",
    "Sound\\Spells\\WhirlwindLoop.wav",
    "Sound\\Spells\\WhirlwindShort.wav",
    "Sound\\Spells\\YarrrrImpact.wav",
    "Sound\\Spells\\arcanepower_state_chest.wav",
    "Sound\\Spells\\avengingwrath_impact_base.wav",
    "Sound\\Spells\\banish_chest_purpleLoop.wav",
    "Sound\\Spells\\bind2_Impact_Base.wav",
    "Sound\\Spells\\bloodbolt_chestLoop.wav",
    "Sound\\Spells\\bloodlust_player_cast_head.wav",
    "Sound\\Spells\\circle_of_renewal_impact.wav",
    "Sound\\Spells\\consume_magic_impact.wav",
    "Sound\\Spells\\deadly_throw_impact_chest.wav",
    "Sound\\Spells\\earthshield_impact_base.wav",
    "Sound\\Spells\\forceofnature_impact.wav",
    "Sound\\Spells\\giftofnaaru.wav",
    "Sound\\Spells\\incinerate_impact_base.wav",
    "Sound\\Spells\\misdirection_impact_head.wav",
    "Sound\\Spells\\mutilate_impact_chest.wav",
    "Sound\\Spells\\prayerofmending_impact_head.wav",
    "Sound\\Spells\\sealofblood_impact_base.wav",
    "Sound\\Spells\\sealofcrusader_impact.wav",
    "Sound\\Spells\\sealoflight_impact_base.wav",
    "Sound\\Spells\\sealofvengeance_impact_base.wav",
    "Sound\\Spells\\shadowfury_impact_base.wav",
    "Sound\\Spells\\soulshatter_impact.wav",
    "Sound\\Spells\\spellreflection_state_shield.wav",
    "Sound\\Spells\\symbolofhope_impact_base.wav",
    "Sound\\Spells\\unstableaffliction_impact_chest.wav",
    "Sound\\Spells\\valentines_brokenheart.wav",
    "Sound\\Spells\\valentines_lookingforloveheart.wav",
    "Sound\\Spells\\victory_rush_impact.wav",
    "Sound\\Spells\\watershield_impact_base.wav",
    "Sound\\Spells\\wellofsouls_base.wav",
    "Sound\\Spells\\AcidCloudBreathFast.wav",
    "Sound\\Spells\\AcidCloudBreathSlow.wav",
    "Sound\\Spells\\AkilzonBirdSwoosh1.wav",
    "Sound\\Spells\\AkilzonBirdSwoosh2.wav",
    "Sound\\Spells\\AkilzonBirdSwoosh3.wav",
    "Sound\\Spells\\AkilzonBirdSwoosh4.wav",
    "Sound\\Spells\\AkilzonEagleSpell1.wav",
    "Sound\\Spells\\AkilzonEagleSpell2.wav",
    "Sound\\Spells\\AkilzonEagleSpell3.wav",
    "Sound\\Spells\\AlchemyCauldronImpactAll.wav",
    "Sound\\Spells\\AnveenaPrisonLoop.wav",
    "Sound\\Spells\\Arcane_Form_Precast.wav",
    "Sound\\Spells\\Blade_of_Azzinoth_Impact.wav",
    "Sound\\Spells\\Bomb_ExplosionPumpkin1.wav",
    "Sound\\Spells\\Bomb_ExplosionPumpkin2.wav",
    "Sound\\Spells\\Bomb_ExplosionPumpkin3.wav",
    "Sound\\Spells\\Bonk1.wav",
    "Sound\\Spells\\Bonk2.wav",
    "Sound\\Spells\\Bonk3.wav",
    "Sound\\Spells\\BrutallasBreakIceDoor.wav",
    "Sound\\Spells\\BurrowWormBirth.wav",
    "Sound\\Spells\\BurrowWormPrecast1.wav",
    "Sound\\Spells\\BurrowWormPrecast2.wav",
    "Sound\\Spells\\BurrowWormPrecast3.wav",
    "Sound\\Spells\\BurrowWormPrecast4.wav",
    "Sound\\Spells\\BurrowWormPrecast5.wav",
    "Sound\\Spells\\BurrowWormPrecast6.wav",
    "Sound\\Spells\\ChainLightning_Fel_Impact_Chest.wav",
    "Sound\\Spells\\ChristmasSnowRain.wav",
    "Sound\\Spells\\ConcussiveShotImpact.wav",
    "Sound\\Spells\\Creature_SpellPortalLarge_All_Colors.wav",
    "Sound\\Spells\\Creature_SpellPortal_LargeShadow.wav",
    "Sound\\Spells\\DisarmTrap1.wav",
    "Sound\\Spells\\DisarmTrap2.wav",
    "Sound\\Spells\\DisarmTrap3.wav",
    "Sound\\Spells\\DisarmTrap4.wav",
    "Sound\\Spells\\DisarmTrap5.wav",
    "Sound\\Spells\\EyeBlastVisual.wav",
    "Sound\\Spells\\FelEnergyCosmeticLoop.wav",
    "Sound\\Spells\\FieBlast_Blue_ImpactA.wav",
    "Sound\\Spells\\FieBlast_Blue_ImpactB.wav",
    "Sound\\Spells\\FieBlast_Blue_ImpactC.wav",
    "Sound\\Spells\\FireBomb1.wav",
    "Sound\\Spells\\FireBomb2.wav",
    "Sound\\Spells\\FireBomb3.wav",
    "Sound\\Spells\\FireBomb4.wav",
    "Sound\\Spells\\FireBombImpact1.wav",
    "Sound\\Spells\\FireBombImpact2.wav",
    "Sound\\Spells\\FireBombImpact3.wav",
    "Sound\\Spells\\Fire_Form_Precast.wav",
    "Sound\\Spells\\FlamingPumpkinHeadMissileLoop.wav",
    "Sound\\Spells\\FrostSlash_Base_Cast.wav",
    "Sound\\Spells\\Frost_Form_Precast.wav",
    "Sound\\Spells\\GlassBreaking1.wav",
    "Sound\\Spells\\GlassBreaking2.wav",
    "Sound\\Spells\\GlassBreaking3.wav",
    "Sound\\Spells\\GoblinBreathChili.wav",
    "Sound\\Spells\\Goblin_Weather_Machine_Cloudy.wav",
    "Sound\\Spells\\Goblin_Weather_Machine_Lightning.wav",
    "Sound\\Spells\\Goblin_Weather_Machine_Rain.wav",
    "Sound\\Spells\\Goblin_Weather_Machine_Snow.wav",
    "Sound\\Spells\\Goblin_Wheather_Machine_Sunny.wav",
    "Sound\\Spells\\Holy_Form_Precast.wav",
    "Sound\\Spells\\IceVeinsA.wav",
    "Sound\\Spells\\IceVeinsB.wav",
    "Sound\\Spells\\IceVeinsC.wav",
    "Sound\\Spells\\IceVeinsD.wav",
    "Sound\\Spells\\IceVeinsE.wav",
    "Sound\\Spells\\IceVeinsF.wav",
    "Sound\\Spells\\IllidanFlameCrashVar1.wav",
    "Sound\\Spells\\IllidanFlameCrashVar2.wav",
    "Sound\\Spells\\IllidanFlameCrashVar3.wav",
    "Sound\\Spells\\IllidanFlameCrashVar4.wav",
    "Sound\\Spells\\IllidanFlameCrashVar5.wav",
    "Sound\\Spells\\IllidanFlameCrashVar6.wav",
    "Sound\\Spells\\IllidanFlameCrashVar7.wav",
    "Sound\\Spells\\IllidanFlameCrashVar8.wav",
    "Sound\\Spells\\IllidanGetBlades.wav",
    "Sound\\Spells\\IllidanShadowBlast1.wav",
    "Sound\\Spells\\IllidanShadowBlast2.wav",
    "Sound\\Spells\\IllidanShadowBlast3.wav",
    "Sound\\Spells\\IllidanShearImpact1.wav",
    "Sound\\Spells\\IllidanShearImpact2.wav",
    "Sound\\Spells\\IllidanShearImpact3.wav",
    "Sound\\Spells\\KilJaedenCustom08.wav",
    "Sound\\Spells\\KilJaedenCustomSpell07_01.wav",
    "Sound\\Spells\\KilJaedenCustomSpell07_02.wav",
    "Sound\\Spells\\KilJaedenCustomSpell07_03.wav",
    "Sound\\Spells\\KilJaedenShadowSpikeMissile.wav",
    "Sound\\Spells\\KilJaedenSoulFlayLoop.wav",
    "Sound\\Spells\\KillCommand.wav",
    "Sound\\Spells\\KrakkenWhirlwind.wav",
    "Sound\\Spells\\Lightning_Fel_Precast_Low_Hand.wav",
    "Sound\\Spells\\MadrigosaSummonFelblaze.wav",
    "Sound\\Spells\\MaievCageTrapVisualLoop.wav",
    "Sound\\Spells\\MeteorImpactBase1.wav",
    "Sound\\Spells\\MeteorImpactBase2.wav",
    "Sound\\Spells\\MeteorImpactBase3.wav",
    "Sound\\Spells\\MidSummer-TorchGameComplete.wav",
    "Sound\\Spells\\MidSummerFlamebreath.wav",
    "Sound\\Spells\\NagaMissileLoop.wav",
    "Sound\\Spells\\Nature_Form_Precast.wav",
    "Sound\\Spells\\ProtectorateIgniter.wav",
    "Sound\\Spells\\RainofTreats.wav",
    "Sound\\Spells\\SeepingGaseous_Fel_Nova.wav",
    "Sound\\Spells\\ShadowStepImpact.wav",
    "Sound\\Spells\\SimonGame_Visual_BadPress.wav",
    "Sound\\Spells\\SimonGame_Visual_GameFailedLarge.wav",
    "Sound\\Spells\\SimonGame_Visual_GameFailedSmall.wav",
    "Sound\\Spells\\SimonGame_Visual_GameStart.wav",
    "Sound\\Spells\\SimonGame_Visual_GameTick.wav",
    "Sound\\Spells\\SimonGame_Visual_LevelStart.wav",
    "Sound\\Spells\\SoulExpelVortex1.wav",
    "Sound\\Spells\\SoulExpelVortex10.wav",
    "Sound\\Spells\\SoulExpelVortex2.wav",
    "Sound\\Spells\\SoulExpelVortex3.wav",
    "Sound\\Spells\\SoulExpelVortex4.wav",
    "Sound\\Spells\\SoulExpelVortex5.wav",
    "Sound\\Spells\\SoulExpelVortex6.wav",
    "Sound\\Spells\\SoulExpelVortex7.wav",
    "Sound\\Spells\\SoulExpelVortex8.wav",
    "Sound\\Spells\\SoulExpelVortex9.wav",
    "Sound\\Spells\\SummonBroomStick1.wav",
    "Sound\\Spells\\SummonBroomStick2.wav",
    "Sound\\Spells\\SummonBroomStick3.wav",
    "Sound\\Spells\\SummonGyrocopter.wav",
    "Sound\\Spells\\SummonReindeer.wav",
    "Sound\\Spells\\SummonRidingTalbuk.wav",
    "Sound\\Spells\\Sunwell_BeamFX.wav",
    "Sound\\Spells\\Sunwell_Fel_PortalStand.wav",
    "Sound\\Spells\\ThrowWater.wav",
    "Sound\\Spells\\TreeDisguise.wav",
    "Sound\\Spells\\ValentineFirework.wav",
    "Sound\\Spells\\WaterElementalLow_Imapct_Base1.wav",
    "Sound\\Spells\\WaterElementalLow_Imapct_Base2.wav",
    "Sound\\Spells\\WaterElementalLow_Imapct_Base3.wav",
    "Sound\\Spells\\WaterShield.wav",
    "Sound\\Spells\\WaterShieldStatic.wav",
    "Sound\\Spells\\WaterSteam_Impact1.wav",
    "Sound\\Spells\\WaterSteam_Impact2.wav",
    "Sound\\Spells\\WaterSteam_Impact3.wav",
    "Sound\\Spells\\ZulAmanTransformFrog.wav",
    "Sound\\Spells\\mage_dragons_breath.wav",
}

local frame = CreateFrame("Frame")
frame:RegisterEvent("UNIT_SPELLCAST_SENT")
frame:RegisterEvent("UNIT_SPELLCAST_STOP")
frame:RegisterEvent("UPDATE_MOUSEOVER_UNIT")
frame:RegisterEvent("CRITERIA_UPDATE")

frame:SetScript("OnEvent", function(self, event, ...)
    if event == "UNIT_SPELLCAST_SENT" then
        silence = true
    elseif event == "UNIT_SPELLCAST_STOP" then
        silence = false
    elseif event =="UPDATE_MOUSEOVER_UNIT" then
	self:CheckTarget()
    elseif event =="CRITERIA_UPDATE" then
	self:UpdateState()
    end
end)
frame:SetScript("OnUpdate", function(self, elapsed)
    if not egg then
        egg = GetItemInfo(45072)
        if egg then
            self:SetScript("OnUpdate", nil)
        end
    end
end)

GameTooltip:HookScript("OnTooltipSetItem", function(self)
    silence = true
end)
GameTooltip:HookScript("OnTooltipCleared", function(self)
    silence = false
end)
GameTooltip:HookScript("OnUpdate", function(self, elapsed)
    if GameTooltipTextLeft1:GetText() == egg then
        if not silence then
            PlaySoundFile("Interface\\AddOns\\HandyEggFinder\\ting.wav")
            if HandyEggFinderDB.random then
                local sound = sounds[math.random(#sounds)]
                PlaySoundFile(sound)
            end
            if HandyEggFinderDB.warn then
                RaidNotice_AddMessage(RaidBossEmoteFrame, "Zomg it's an egg!", ChatTypeInfo["RAID_WARNING"] );
            end
            silence = true
        end
    end
end)

-- Spring Flower/Race detection added by Wobin
local springflowers = 45073
local springbuff = (GetItemSpell(springflowers))
local AchievementStatus = {}
local StatusInitialised = false

function frame:UpdateState()
    for i=1,10 do
        local race, _, bunnied = GetAchievementCriteriaInfo(2422,i)
        AchievementStatus[race] = bunnied
    end
end

function frame:CheckTarget()
    if not UnitIsPlayer("mouseover") then return end -- Not an NPC
    if UnitSex("mouseover") ~= 3 then return end -- Not a female
    if UnitLevel("mouseover") < 18 and UnitLevel("mouseover") > 0 then return end -- Not of the appropriate level
    if (GetItemCooldown(springflowers)) ~= 0 then return end -- Can't use our item yet
    if UnitBuff("mouseover", springbuff) then return end -- She already has the buff
    if not StatusInitialised then 
        StatusInitialised = true
        self:UpdateState() 
    end -- Initialise our dataset
    if AchievementStatus[(UnitRace("mouseover"))] then return end -- We've tagged this race already
    -- okay, finally we have a valid target!
    PlaySoundFile("Interface\\AddOns\\HandyEggFinder\\ting.wav")
    if HandyEggFinderDB.random then
        local sound = sounds[math.random(#sounds)]
        PlaySoundFile(sound)
    end
    if HandyEggFinderDB.warn then
        RaidNotice_AddMessage(RaidBossEmoteFrame, "Quick, Bunny "..UnitName("mouseover").."! She's a "..(UnitRace("mouseover")).."!", ChatTypeInfo["RAID_WARNING"] );
    end
end
